Attribute VB_Name = "ConvertLocalDate"
Option Explicit

' Ive made this module from code created by Julien Brunelle.
' Search on Planet Source for it (use Cdate as keyword)
' its about differences in local settings in other countries and the
' trouble that it can cause with the Cdate function...
'(which is the reason why this functions are implemented in this program now)

Private Const LOCALE_SSHORTDATE = &H1F
Private Const LOCALE_USER_DEFAULT As Long = &H400

Private Declare Function GetLocaleInfo Lib "KERNEL32" Alias "GetLocaleInfoA" (ByVal lLocale As Long, ByVal lLocaleType As Long, ByVal sLCData As String, ByVal lBufferLength As Long) As Long

Public Function GetDateFormat() As String
    Dim lReturn As Long
    Dim sBuffer As String
    Dim lBufferLength As Long
        lBufferLength = 128
        sBuffer = String$(lBufferLength, 0)

        lReturn = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SSHORTDATE, sBuffer, lBufferLength)

        If lReturn > 0 Then
            GetDateFormat = Left$(sBuffer, lReturn - 1)
        End If
End Function

Public Function Fixeddate(sImportDate As String, sFormat As String) As Date
On Error GoTo errHandle

Dim splitFormat1, splitFormat2, SplitDate
Dim separator1 As String, separator2 As String
Dim iloop As Integer, iloop2 As Integer
Dim ComputerFormat As String
Dim newDate As String
ComputerFormat = GetDateFormat

For iloop = 1 To Len(ComputerFormat)
    If InStr(1, "dmy", Mid(LCase(ComputerFormat), iloop, 1), vbTextCompare) = 0 Then
        separator1 = Mid(LCase(ComputerFormat), iloop, 1)
        Exit For
    End If
Next

For iloop = 1 To Len(sFormat)
    If InStr(1, "dmy", Mid(LCase(sFormat), iloop, 1), vbTextCompare) = 0 Then
        separator2 = Mid(LCase(sFormat), iloop, 1)
        Exit For
    End If
Next
splitFormat1 = Split(ComputerFormat, separator1)
splitFormat2 = Split(sFormat, separator2)
SplitDate = Split(sImportDate, separator2)
For iloop = 0 To UBound(splitFormat1)
     For iloop2 = 0 To UBound(splitFormat2)
        If LCase(Mid(splitFormat1(iloop), 1, 1)) = LCase(Mid(splitFormat2(iloop2), 1, 1)) Then
            If iloop = UBound(splitFormat1) Then
                newDate = newDate & SplitDate(iloop2)
            Else
                newDate = newDate & SplitDate(iloop2) & separator1
            End If
            Exit For
        End If
     Next
Next
Fixeddate = newDate
Exit Function
errHandle:
MsgBox Err.Description, vbCritical
    
End Function

